https://community.topcoder.com/stat?c=problem_statement&pm=1889&rd=4709
http://www.voidcn.com/article/p-roeligee-hm.html
https://blog.csdn.net/SlightK/article/details/53368547
Another possible solution:
For a M*N map, all the possilbe ways is C (M)(M+N).
For some blocked ways, we first consider the ways we take on these blocked ways, one by one. Then we subtract it from the C (M)(M+N).But we have to be careful because there are some ways we subtract twice so we have to add them back. Finally we can also get the correct answer.
https://github.com/irpap/TopCoder/blob/master/AvoidRoads/src/AvoidRoads.java
In the city, roads are arranged in a grid pattern. Each point on the grid represents a corner where two blocks meet. The points are connected by line segments which represent the various street blocks. Using the cartesian coordinate system, we can assign a pair of integers to each corner as shown below. You are standing at the corner with coordinates 0,0. Your destination is at corner width,height. You will return the number of distinct paths that lead to your destination. Each path must use exactly width+height blocks. In addition, the city has declared certain street blocks untraversable. These blocks may not be a part of any path. You will be given a String[] bad describing which blocks are bad. If (quotes for clarity) "a b c d" is an element of bad, it means the block from corner a,b to corner c,d is untraversable. For example, let's say width = 6 length = 6 bad = {"0 0 0 1","6 6 5 6"}The picture below shows the grid, with untraversable blocks darkened in black. A sample path has been highlighted in red. | |||||||||||||
Definition | |||||||||||||
| |||||||||||||
Constraints | |||||||||||||
- | width will be between 1 and 100 inclusive. | ||||||||||||
- | height will be between 1 and 100 inclusive. | ||||||||||||
- | bad will contain between 0 and 50 elements inclusive. | ||||||||||||
- | Each element of bad will contain between 7 and 14 characters inclusive. | ||||||||||||
- | Each element of the bad will be in the format "a b c d" where,
| ||||||||||||
- | The return value will be between 0 and 2^63-1 inclusive. | ||||||||||||
Examples | |||||||||||||
0) | |||||||||||||
|
http://www.voidcn.com/article/p-roeligee-hm.html
题目描述:在整数坐标系中,找从(0,0)到(width,height)的不同路径,每条路径的长度必须是width+height,这说明点只能向右和向上移动。并且还有一些坐标之间的路径是不能经过的。
思路:grid[i][j]表示从(0,0)到(i,j)不同路径的数目,则grid[i][j]=gird[i-1][j]+grid[i][j-1]
http://www.cnblogs.com/lautsie/p/3258732.html
二维动态规划。和某一道leetcode的题目差不多。就是多了blocks的数组或集合。
本次解题的心得有:1.根据题意使用集合表示阻碍;2.使用字符串的形式表示整数的pair,简洁明了;3.p1到p2的阻碍其实是双向的;4.可以不用首行首列的全0;5.mx[i][j]和mx[i-1][j]和mx[i-1][j]可以分别加的。
public
long
numWays(
int
width,
int
height, String[] bad) {
HashMap<String,HashSet<String>> blocks =
new
HashMap<String,HashSet<String>>();
for
(String badStr : bad) {
String[] bl = badStr.split(
" "
);
int
x1 = Integer.parseInt(bl[
0
]);
int
y1 = Integer.parseInt(bl[
1
]);
int
x2 = Integer.parseInt(bl[
2
]);
int
y2 = Integer.parseInt(bl[
3
]);
String p1 =
""
+ x1+
":"
+ y1;
String p2 =
""
+ x2 +
":"
+ y2;
// p1 -> p2 && p2-> p1 are blocked
if
(!blocks.containsKey(p1)) {
HashSet<String> set =
new
HashSet<String>();
blocks.put(p1, set);
}
if
(!blocks.containsKey(p2)) {
HashSet<String> set =
new
HashSet<String>();
blocks.put(p2, set);
}
blocks.get(p1).add(p2);
blocks.get(p2).add(p1);
}
long
mx[][] =
new
long
[width+
1
][height+
1
];
for
(
int
i =
0
; i < width+
1
; i++) {
for
(
int
j =
0
; j < height+
1
; j++) {
if
(i ==
0
&& j ==
0
) {
mx[i][j] =
1
;
}
else
{
String s0 =
""
+i+
":"
+j;
String s1 =
""
+(i-
1
)+
":"
+j;
String s2 =
""
+i+
":"
+(j-
1
);
if
(i >
0
&& !(blocks.containsKey(s1) && blocks.get(s1).contains(s0))) {
mx[i][j] += mx[i-
1
][j];
}
if
(j >
0
&& !(blocks.containsKey(s2) && blocks.get(s2).contains(s0))) {
mx[i][j] += mx[i][j-
1
];
}
}
}
}
return
mx[width][height];
}
Another possible solution:
For a M*N map, all the possilbe ways is C (M)(M+N).
For some blocked ways, we first consider the ways we take on these blocked ways, one by one. Then we subtract it from the C (M)(M+N).But we have to be careful because there are some ways we subtract twice so we have to add them back. Finally we can also get the correct answer.
public static long numWays(int width, int height, String[] bad) {
long[][] map = new long[width + 2][height + 2]; // map refer to the corners.
String[][] block = new String[bad.length][4]; // block refer to the blocked roads.
// change the block string so that we can set the second postion further in the map.
for (int k = 0; k < bad.length; k++) {
block[k] = bad[k].split(" ");
if (Integer.parseInt(block[k][0]) > Integer.parseInt(block[k][2])) {
String temp = "";
temp = block[k][0];
block[k][0] = block[k][2];
block[k][2] = temp;
}
if (Integer.parseInt(block[k][1]) > Integer.parseInt(block[k][3])) {
String temp = "";
temp = block[k][1];
block[k][1] = block[k][3];
block[k][3] = temp;
}
}
for (int row = 0; row < height + 2; row++) {
for (int col = 0; col < width + 2; col++) {
if (row == 0 || col == 0)
// I add two lines off the map system to show there is no way on the edge.
map[row][col] = 0;
else {
map[row][col] = map[row - 1][col] + map[row][col - 1];
// Here is the key point.First we calculate the possible solution without
// thinking the blocked ones.
for (int k = 0; k < bad.length; k++) {
if (col == (Integer.parseInt(block[k][2]) + 1)
&& row == (Integer.parseInt(block[k][3]) + 1)) {
// if the corner is blocked,we have to distract it.
map[row][col] -= map[Integer.parseInt(block[k][1]) + 1][Integer
.parseInt(block[k][0]) + 1];
}
}
map[1][1] = 1; // Be sure map[1][1] is 1.
}
}
}
for (int i = width + 1; i > -1; i--) {
System.out.println(Arrays.toString(map[i]));
}
return map[width + 1][height + 1];
}
http://blog.csdn.net/wang1990wen/article/details/41986961https://github.com/irpap/TopCoder/blob/master/AvoidRoads/src/AvoidRoads.java